;--------------------------------------------------------
; 1)    奬 
; 2) । ࠧ 
; 3) ࠥ
; 4) ஢ 

Erase:
	call Ident

	Call EnableWork

	mov al,Manufacture

        case Intel,eIntel
        case AMD,eAMD
        case SST,eSST
        case Atmel,eAtmel
        case Winbond,eWinbond
        case MX,eMX
        case Thomson,eThomson
        case Eon,eEON
        case ISSI,eISSI
        case MoselVitelic,eMosel

	displayString AbortErase

EraseExit:
	call DisableWork
	stc
ret
;======================================================
;======================================================
eIntel:
	mov al,device
	case 094h,eI28F001BXT
	displayString AbortEraseAlg
	stc
ret
;------------------------------------------------------
eI28F001BXT:
; i28F001BXT      ⤥쭮

	call SetVpp12V		; 稫 殮 ணࠬ஢
	call ResetAdress       ;  0
	
	DisplayString EBlock0
	 call eOneBlock
	  jc EndeI28F001BXT

	outport HiHiport,0FFH 
	outport Hiport,0C0h 	;  1

	DisplayString EBlock1
	 call eOneBlock
	  jc EndeI28F001BXT

	Outport Hiport,0D0h 	;  2

	DisplayString EBlock2
	 call eOneBlock
	  jc EndeI28F001BXT

	Outport Hiport,0E0h 	;  3
	DisplayString EBlock3
	 call eOneBlock
	  jc EndeI28F001BXT
	
	call resetAdress
	outport DataPort,0ffh ; ॢ  ० ⥭

	MOV BL,0FFH
	call testClearNew

EndeI28F001BXT:
ret
;----------------------------

eOneBlock:
	OutPort DataPort,050h	;    

call Setoe12V		
	
	outPort DataPort,020h	;  
	outPort DataPort,0D0h	;   

call SetoeNormal		
	
	OutPort DataPort,070h	;    
	in al,dx		; ⠫

	Test al,00001000b	; 殮 Vpp  ଥ?
	jz NotErrorVpp
	DisplayString ErrorVpp
	stc
	ret			; 뢠  訡

NotErrorVpp:
	Test al,00100000b	;  ஡ ࠭ ?
	jz NotEraseProblem
	DisplayString ErrorEraseProblem
	stc
	ret			; 뢠  訡


NotEraseProblem:
	DisplayString WaitReady
CykleWait:
	OutPort DataPort,70h	;    
	in al,dx
	and al,11000000b
	cmp al,10000000b	
	je OkEraseBlock		; Write Status Mashine ⮢  ࠡ
				;  ⪠ 襭

	cmp al,01000000b	; ६ ࠭ ⥪ ?
	je FailEraseBlock	; Write Status Mashine ⮢  ࠡ
				;    
	jmp CykleWait

 OkEraseBlock:
	DisplayString OkEraseBlockMessage
	clc
 ret
 FailEraseBlock:
	DisplayString ErrorEraseBlock
	stc
 ret

ErrorVpp db 10D,13D, ' ࠯ > 殮 ணࠬ஢   ଥ!!!$' 
ErrorEraseProblem db 10D,13D, ' ࠯ > 訡 ࠭!!!$' 
ErrorEraseBlock db 10D,13D, ' ࠯ >   !!!$' 

OkEraseBlockMessage db 10D,13D, ' ࠯ >  $' 

EBlock0 db 10D,13D,"  0/3 $"
EBlock1 db 10D,13D,"  1/3 $"
EBlock2 db 10D,13D,"  2/3 $"
EBlock3 db 10D,13D,"  3/3 $"
;------------------------------------------------------
	
;======================================================
eAMD:
	mov al,device
	case 0B0h,eAM29F002NBT
	displayString AbortEraseAlg
	stc	
ret
;------------------------------------------------------
eAM29F002NBT:
	call eAmdMx
ret

;======================================================
; 㭨ᠫ쭠 ணࠬ ࠭  AMD  MX
eAmdMX:
	displayString EraseOn
	WriteAdress 0555h,0AAh
	WriteAdress 02AAh,055h
	WriteAdress 0555h,080h
	WriteAdress 0555h,0AAh
	WriteAdress 02AAh,055h
	WriteAdress 0555h,010h

call Pause50ms
	
	call WaitToggle
	mov bl,0FFh
	call TestClearNew
ret
;======================================================
eSST:
	mov al,device
	case 07h,ePH29EE010
	case 010h,ePH29EE010    ; 29SEE020
	case 0B5h,ePH29EE010    ; 39SF010
	case 0B6h,ePH29EE010	; 39SF020

	displayString AbortEraseAlg
	stc	
ret
;------------------------------------------------------
ePH29EE010:
	call eJEDEC		;  㭨ᠫ ணࠬ ࠭
	mov bl,0ffh
	call TestClearNew
ret

;======================================================
eAtmel:
	mov al,device
	case 0D5h,eAT29C010
	case 017h,eAT29C010
	case 008h,eAT29C010

	displayString AbortEraseAlg
	stc
ret
;------------------------------------------------------
eAT29C010:
	call eJEDEC		;  㭨ᠫ ணࠬ ࠭
	mov bl,0ffh
	call TestClearNew
ret

;======================================================
eWinbond:
	mov al,device
	case 008h,eW27E512     ; 27E512

	case 0C1h,eW29EE010
	case 045h,eW29EE010	;  29EE010

	case 00bh,eW49F002U	;W49F002U
	displayString AbortEraseAlg
	stc
ret
;------------------------------------------------------
eW27E512:
	displayString EraseOn
        call Setoe12V		
        call SetVid12V		
	call Pause50ms

	mov dx, dataPort
	in al,dx

	call Pause50ms
	call Pause50ms

        call SetoeNormal		
        call SetVidNormal		
	call Pause50ms

	mov bl,0ffh
	call TestClearnew
ret
;------------------------------------------------------
eW29EE010:
	call eJEDEC		;  㭨ᠫ ணࠬ ࠭
	mov bl,0ffh
	call TestClearNew
ret
;------------------------------------------------------
eW49F002U:		;   1 RESET
	Outport HiHiPort,11111100b
	call eJEDEC		;  㭨ᠫ ணࠬ ࠭
	mov bl,0ffh
	call TestClearNew
ret
;======================================================
eMX:
	call EnableWork
	mov al,device

	case 018h,eMX29F001T	;  MX29F001B 筮
	case 0B0h,eMX29F001T	;  MX29F002NT 筮
	case 019h,eMX29F001T

	case 01Ah,eMX28F1000

	case 03Ch,eMX28F2000T
	case 02Ah,eMX28F2000P	
	
	displayString AbortEraseAlg
	stc
ret
;-------------------------------------
eMX29F001T:
	mov al,byte3	; ⨩   䨪樨 
	cmp al,0	;  
	je NotProtect
	cmp al,1	;  
	jne ErrorProtectByte	;  ࠢ쭮 ⠭  

Unprotect:		; ꥬ 

	DisplayString ProtectGo
	call setVid12v		
	call setoe12v		
	CALL PAUSE10MS		
	mov dx,DataPort
	out dx,al
	call WaitToggle
	call SetoeNormal	; ⠭   OE ᨣ OE

	outport LoPort,2
	mov dx,dataPort

	in al,dx		; ⨩ 
	mov bl,al
	call SetVidNormal	; ⠭   A9 ᨣ A9

	cmp bl,0
	jne EUPMX29F001 

NotProtect:
	call eAmdMx	; ⨯筠 楤  ⠪ ⨯
	ret

EUPMX29F001:
	DISPLAYString ErrorUnProtectMxChip
	stc
ret
	
;---------
ErrorProtectByte:	;  ࠢ쭮 ⠭   ਩ 室
	DisplayString Byte3Fail
	stc
ret
;-------------------------------------
eMX28F2000T:
	displayString EraseOn
	call SetVpp12V	; 殮 oࠬ஢ 
	outport DataPort,20H 
	outport DataPort,20H 
	call pause50ms
	call pause50ms
	call pause50ms
	call pause50ms
	call SetVppNormal
	outport DataPort,0ffH 
	mov bl,0h
	call TestClearNew		; ஢塞 ࠭
	Call DisableWork
	stc
ret
;-------------------------------------
eMX28F2000P:

	displayString EraseOn
	call SetVpp12V	; 殮 oࠬ஢ 
	outport DataPort,30H 
	outport DataPort,30H 

	call pause50ms
	call WaitToggle	

	call SetVppNormal
	outport DataPort,0ffH 
	mov bl,0h
	call TestClearNew		; ஢塞 ࠭
ret

;-------------------------------------

eMX28F1000:
	displayString EraseOn
	call SetVpp12V	; 殮 oࠬ஢ 
	outport DataPort,30H 
	outport DataPort,30H 	;   

	mov cx, 20d

Wait10s:
	call Pause50ms
	mov dx,DataPort
	in al,dx
	and al,80h
	jnz Erase28F1000oK	

	dec cx
	jnz Wait10S

Erase28F1000oK:
	mov bl,0FFh
	call TestClearnew		; ஢塞 ࠭
ret

;======================================================
eThomson:

; Thomson M29F002T  M29F002B   #RP - 

	mov al,device
	case 0b0h, eM29F002	; Thomson M29F002T/NT     
	case 034h, eM29F002	; Thomson M29F002B

	displayString AbortEraseAlg
	stc 
	ret	

eM29F002:
	displayString EraseOn
	mov al,11111100b	; A16,A17    #RP ᫨    1
	mov dx,HiHiPort
	out dx,al
	call pause10ms

	WriteAdress 0555h,0AAh
	WriteAdress 0AAAh,055h
	WriteAdress 0555h,080h
	WriteAdress 0555h,0AAh
	WriteAdress 0AAAh,055h
	WriteAdress 0555h,010h

	call pause10ms

	call WaitToggle
	mov bl,0ffh
	call TestClearNew

ret
;-------------------------
EEON:
	mov al,device
	case 092h, eEON29F002	; EON EN29F002T/NT     
	case 097h, eEON29F002	; EON EN29F002B/BNT     
	displayString AbortEraseAlg
	stc
	ret

eEON29F002:

	WriteAdress 0555h,0F0h         ; ० ⥭
	call pause10ms


	WriteAdress 05555h,0AAh
	WriteAdress 0AAAAh,055h
	WriteAdress 05555h,080h
	WriteAdress 05555h,0AAh
	WriteAdress 0AAAAh,055h
	WriteAdress 05555h,010h

	call WaitToggle

	WriteAdress 0555h,0F0h         ; ० ⥭
	call pause10ms

	mov bl,0ffh
	call TestClearNew

ret

;=========================================================
;qqq
EISSI:
	mov al,device
	case 0B4h, eIS28F010	
	displayString AbortEraseAlg
	stc
	ret

eIS28F010:
	displayString EraseOn
	call SetVpp12V	; 殮 oࠬ஢ 
	call resetAdress

	Outport DataPort,20h    ;  ࠭
	call pause50ms		; 뤥ঠ  5 ࠧ  
	Outport DataPort,20h	;  ࠭

	Outport DataPort,0FFh	; 
	Outport DataPort,0FFh	; 

	call SetVppNormal

	mov bl,0ffh
	call TestClearNew
ret

;======================================================
EMosel:

	call resetAdress
	call eJEDEC
	mov bl,0ffh
	call TestClearNew
	ret
;======================================================


eJEDEC:
	displayString EraseOn

	WriteAdress 5555h,0AAh
	WriteAdress 2AAAh,055h
	WriteAdress 5555h,080h
	WriteAdress 5555h,0AAh
	WriteAdress 2AAAh,055h
	WriteAdress 5555h,010h

	call Pause50ms
	call WaitToggle

ret
;=========================================================
TestClearNew:
; 室 bl ⠫  ࠢ
; 筮 FF  뢠 稯    00
; ஢ઠ  
;  C=1  饭 =0 ,

	call ResetAdress
	mov dx,DataPort
	mov di,Offset SizeChip
	mov ax,[di+1]	; ࠧ  256  
	mov BlockCounter,ax

LongCyckleCLEAR:
	mov cx,256d		; 襥 ᫮ ࠧ
ShortCyckleCLEAR:

	in al,dx
	cmp al,bl
	jne NotErease
	call incrementA

	loop ShortCyckleClear	;  ࠭ ⠫ ?

	dec BlockCounter
	jnz LongCyckleCLEAR	; 稫 ࠭ ?
	DisplayString OK
	clc
ret
NotErease:
	DisplayString FailEreaseString 
	stc			;  ⨫
ret
;=========================================================
;--------------------------------------------------------------------
ErrorUnProtectMxChip db 10d,13d,'  稯 MX  !!!$'
OkUnProtectMxChip db 10d,13d,'  稯 MX  ᯥ譮$'
OK db 'OK$'
FailEreaseString db 10d,13d, '  o饭 $'
AbortErase db 10d,13d,' ࠭ ⪠.  ந⥫$'
AbortEraseAlg db 10d,13d,' ࠭ ⪠.  $'
EraseOn db 10D,13D, "   $"
WaitEreaseNotSucc db 10d,13d,'  WaitToggle$'
DataPollingNotSucc db 10d,13d,'Data Polling <>1$'
WaitReady db 10D,13D, " 砭 ࠭ $"
ProtectGo db 10D,13D,"   $"
Byte3Fail db 10D,13D," ࠢ   $"


